package spaceinvaders;

import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JPanel;

public class JAlien extends JComponent implements Runnable {

    private final Icon icon = new ImageIcon(getClass().getResource("/spaceinvaders/images/alien.gif"));

    public JAlien() {
        this.setMinimumSize(new Dimension(icon.getIconWidth(), icon.getIconHeight()));
        this.setPreferredSize(new Dimension(icon.getIconWidth(), icon.getIconHeight()));

        Thread thread = new Thread(this);
        thread.setDaemon(true);
        thread.start();
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        if (icon != null)
            icon.paintIcon(this, g, 0, 0);
    }

    @Override
    public void run() {
        while (true) {
            if (Math.random() > 0.9) {
                JPanel pnlSfondo = (JPanel) this.getParent();
                if (pnlSfondo != null) {
                    JAlienLaser laser = new JAlienLaser();
                    laser.setBounds(this.getX() + 22, this.getY() + 20, 1, 10);
                    pnlSfondo.add(laser);
                    laser.setVisible(true);
                    laser.fire();
                }
            }
            try {
                Thread.sleep(1000);
            } catch (InterruptedException ex) {
            }
        }
    }

}
